import { Action } from './types';
import { Task, SagaMiddleware, SagaIterator } from 'redux-saga';
import { SagaOptions } from './types';
declare class SagaRunner<T extends Action = Action> {
    private sagaOptions;
    private subscribes;
    private stores;
    private sagaMiddleware;
    constructor(sagaOptions?: SagaOptions);
    dispatch(action: T): T;
    getState(): {
        [name: string]: any;
    };
    runSaga(saga: () => SagaIterator): Task;
    registerStore(key: string, store: any): void;
    unRegisterStore(key: string): void;
    useSagaMiddleware(middleware: SagaMiddleware<any>): void;
    private subscribe(callback);
}
export default SagaRunner;
